﻿Public Class InputState

    ''' <summary>左方向への移動</summary>
    Public Left As Boolean

    ''' <summary>右方向への移動</summary>
    Public Right As Boolean

    ''' <summary>上方向への移動</summary>
    Public Up As Boolean

    ''' <summary>下方向への移動</summary>
    Public Down As Boolean

    ''' <summary>ビーム発射</summary>
    Public Fire As Boolean

    ''' <summary>スタート。ゲーム開始</summary>
    Public Start As Boolean

    Public DebugMessage As Integer

    ''' <summary>
    ''' ビームは１回のキー操作で１発しか打てないようにするため、
    ''' キーを離したか監視する。
    ''' １回キーを押したときFireSwitchはTrueになり、fireSwitchがTrueの状態では追加のビームは受け付けない。
    ''' キーを離すとFireSwitchはFalseに戻る。
    ''' ※この制御をこのクラスで行うのはよくない。StarAクラスへの移管を検討すること。
    ''' </summary>
    ''' <remarks></remarks>
    Private fireSwitch As Boolean

    ''' <summary>
    ''' キーボードの入力と操作を関連付けます。
    ''' </summary>
    ''' <param name="e"></param>
    ''' <param name="KeyOn">キーが押されたときTrue、離されたときFalseを渡してください。</param>
    ''' <remarks></remarks>
    Public Sub Input(ByVal e As KeyEventArgs, ByVal KeyOn As Boolean)
        Select Case e.KeyCode
            Case Keys.Left
                Me.Left = KeyOn
            Case Keys.Right
                Me.Right = KeyOn
            Case Keys.Up
                Me.Up = KeyOn
            Case Keys.Down
                Me.Down = KeyOn
            Case Keys.Enter
                Me.Start = KeyOn
            Case Keys.Space
                DebugMessage += 1
                Me.Fire = False
                If KeyOn Then
                    If Not fireSwitch Then
                        Me.fireSwitch = True
                        Me.Fire = True
                    End If
                Else
                    Me.fireSwitch = False
                End If


        End Select
    End Sub

End Class