﻿Imports System.Media

Public Class SoundComposer

    Public Shared BGM1 As New BGM(Musics.BGM1)
    Public Shared Explosion1 As New BGM(Musics.Explosion1)
    Public Shared Explosion2 As New BGM(Musics.Explosion2)
    Public Shared Fire1 As New BGM(Musics.Fire1)
    Public Shared Fire2 As New BGM(Musics.Fire2)
    Public Shared Hit As New BGM(Musics.Hit)
    Public Shared PowerUp As New BGM(Musics.PowerUp)
    Public Shared Gameover As New BGM(Musics.Gameover)

End Class

Public Class BGM

    ''' <summary> BGMとして使用するサウンドのファイル名です。wavファイルを指定します。 </summary>
    Protected Property FileName() As String
        Get
            Return m_FileName
        End Get
        Set(ByVal value As String)
            m_FileName = value
        End Set
    End Property
    Private m_FileName As String

    ''' <summary>サウンドを繰り返し再生するか指定します。Trueのとき繰り返し再生します。</summary>
    Public Property IsLoop() As Boolean
        Get
            Return m_IsLoop
        End Get
        Set(ByVal value As Boolean)
            m_IsLoop = value
        End Set
    End Property
    Private m_IsLoop As Boolean

    ''' <summary>Trueのときサウンドが終わるまでプログラムを停止します。</summary>
    Public Property IsWait() As Boolean
        Get
            Return m_IsWait
        End Get
        Set(ByVal value As Boolean)
            m_IsWait = value
        End Set
    End Property
    Private m_IsWait As Boolean

    Private Shared random As New Random
    'Protected AliasName As String

    Public Sub New(ByVal music As Musics)

        'AliasName = "A" & Now.Ticks.ToString & random.Next(1, 100000).ToString

        Select Case music
            Case Musics.BGM1
                FileName = Application.StartupPath & "\sound\Star1Fit.wav"
                IsLoop = True
            Case Musics.Explosion1
                FileName = Application.StartupPath & "\sound\StarSE_Explode1.wav"
            Case Musics.Explosion2
                FileName = Application.StartupPath & "\sound\StarSE_Explode2.wav"
            Case Musics.Fire1
                FileName = Application.StartupPath & "\sound\StarSE_Fire1.wav"
            Case Musics.Fire2
                FileName = Application.StartupPath & "\sound\StarSE_Fire2.wav"
            Case Musics.Hit
                FileName = Application.StartupPath & "\sound\StarSE_Hit2.wav"
            Case Musics.PowerUp
                FileName = Application.StartupPath & "\sound\StarSE_PowerUp.wav"
            Case Musics.Gameover
                FileName = Application.StartupPath & "\sound\StarSE_GameOver.wav"
        End Select

    End Sub

    'Public Sub Play()
    '    Dim player As New SoundPlayer(FileName)

    '    If IsLoop Then
    '        player.PlayLooping()
    '    ElseIf IsWait Then
    '        player.PlaySync()
    '    Else
    '        player.Play()
    '    End If
    'End Sub

    Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Integer, ByVal hwndCallback As Integer) As Integer
    Private Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" (ByVal fdwError As Integer, ByVal lpszErrorText As String, ByVal cchErrorText As Integer) As Integer

    Dim AliasName As String

    Public Sub Play()

        AliasName = "A" & Now.Ticks.ToString & random.Next(1, 100000).ToString

        If IsLoop Then
            My.Computer.Audio.Play(FileName, AudioPlayMode.BackgroundLoop)
        Else
            mciSendString(String.Format("open ""{0}"" alias {1}", FileName, AliasName), "", 0, 0)
            mciSendString(String.Format("play {0}", AliasName), "", 0, 0)
        End If

    End Sub

    Public Sub [Stop]()
        If IsLoop Then
            My.Computer.Audio.Stop()
        Else
            mciSendString(String.Format("close {0}", AliasName), "", 0, 0)
        End If
    End Sub



    Private Function GetErrorString(ByVal APIResult As Integer) As String

        Dim Buffer As String = New String(Chr(0), 255)
        Dim ErrorMessage As String

        Call mciGetErrorString(APIResult, Buffer, Len(Buffer))

        ErrorMessage = Replace(Buffer, Chr(0), "")

        Return ErrorMessage

    End Function

End Class

Public Enum Musics
    BGM1
    Explosion1
    Explosion2
    Fire1
    Fire2
    Hit
    PowerUp
    Gameover
End Enum

'Public Class SoundeComposer

'    Shared Sub Play(ByVal fileName As String, Optional ByVal IsLoop As Boolean = False, Optional ByVal IsWait As Boolean = False)

'        Dim player As New SoundPlayer(fileName)

'        If IsLoop Then
'            player.PlayLooping()
'        ElseIf IsWait Then
'            player.PlaySync()
'        Else
'            player.Play()
'        End If


'    End Sub
'End Class
