﻿Public Class ABomb
    Inherits UnitBase

    Public deltaMove As Integer = 7

    Shared mainImages() As Bitmap
    Private minimumMoveX As Integer = 10
    Private minimumMoveY As Integer = 12

    Protected frameCount As Integer
    Protected currentImageIndex As Integer
    Const ImageChangeFrameCount As Integer = 5

    Shared Attr As New Imaging.ImageAttributes

    Protected TargetPoint As Point

    Public Sub New()

        MyBase.New()

        If mainImages Is Nothing Then
            Dim images As New List(Of Bitmap)
            images.Add(Image.FromFile(Application.StartupPath & "\image\ABomb\ABomb01.bmp"))
            images.Add(Image.FromFile(Application.StartupPath & "\image\ABomb\ABomb02.bmp"))
            ReDim mainImages(images.Count - 1)
            mainImages = images.ToArray

            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            'Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
        End If

        currentImageIndex = 0
        Me.Width = mainImages(currentImageIndex).Width
        Me.Height = mainImages(currentImageIndex).Height

    End Sub

    Public Sub Init(ByVal currentPoint As Point, ByVal targetPoint As Point)
        'targetPointから軌道を計算
        '軌道上を一直線に移動する。
        '移動量は直線距離で一定になるようにX移動量とY移動量を調整する。

        Dim distance As Double = Utility.GetDistance(currentPoint, targetPoint)

        'この距離を移動するのに何フレームかかるか算出
        '\で計算しているから誤差はでるがこのムラがファジー要素となってOK
        Dim neededFrame As Integer = distance \ deltaMove

        If neededFrame = 0 Then
            neededFrame = 1
        End If

        Me.Left = currentPoint.X
        Me.Top = currentPoint.Y
        minimumMoveX = (targetPoint.X - currentPoint.X) \ neededFrame
        minimumMoveY = (targetPoint.Y - currentPoint.Y) \ neededFrame

    End Sub

    Public Overrides Sub Move(ByVal input As InputState)
        Me.Left += minimumMoveX
        Me.Top += minimumMoveY
    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)

        FrameCount += 1

        If FrameCount = ImageChangeFrameCount Then
            FrameCount = 0
            currentImageIndex += 1
            If currentImageIndex = mainImages.Length Then
                currentImageIndex = 0
            End If
        End If

        g.DrawImage(mainImages(currentImageIndex), Me.Rectangle, 0, 0, Me.Width, Me.Height, GraphicsUnit.Pixel, Attr)
    End Sub

    Public Overrides Function IsDead() As Boolean


        If Top > Common.Display.ViewArea.Bottom Then
            Return True
        ElseIf Top < 0 Then
            Return True
        ElseIf Left > Common.Display.ViewArea.Width Then
            Return True
        ElseIf Left < 0 Then
            Return True
        Else
            Return False Or MyBase.IsDead
        End If


    End Function

    Public Overrides Property BelongTo As BelongTo
        Get
            Return BelongTo.Enemy
        End Get
        Set(ByVal value As BelongTo)
            MyBase.BelongTo = value
        End Set
    End Property

    Public Overrides Property AttackPriority As Integer
        Get
            Return 9999
        End Get
        Set(ByVal value As Integer)
            MyBase.AttackPriority = value
        End Set
    End Property

    Public Overrides ReadOnly Property IsFire As Boolean
        Get
            Return True
        End Get
    End Property

End Class
