﻿Public Class FireA
    Inherits UnitBase

    Shared mainImage As Bitmap

    Private deltaMove As Integer = 12

    Private deltaMoveX As Integer
    Private deltaMoveY As Integer

    Shared Attr As New Imaging.ImageAttributes

    Public Sub New(ByVal direction As FireDirections)

        MyBase.New()

        If mainImage Is Nothing Then
            FireA.mainImage = Image.FromFile(Application.StartupPath & "\image\Fire.bmp")
            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            'Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
        End If

        Select Case direction
            Case FireDirections.Forward
                deltaMoveX = 0
                deltaMoveY = -deltaMove
            Case FireDirections.Back
                deltaMoveX = 0
                deltaMoveY = deltaMove
            Case FireDirections.Left
                deltaMoveX = -deltaMove
                deltaMoveY = 0
            Case FireDirections.Right
                deltaMoveX = deltaMove
                deltaMoveY = 0
            Case FireDirections.LeftForward
                deltaMoveX = -deltaMove \ Math.Sqrt(2)
                deltaMoveY = -deltaMove \ Math.Sqrt(2)
            Case FireDirections.RightForward
                deltaMoveX = deltaMove \ Math.Sqrt(2)
                deltaMoveY = -deltaMove \ Math.Sqrt(2)
            Case FireDirections.LeftBack
                deltaMoveX = -deltaMove \ Math.Sqrt(2)
                deltaMoveY = deltaMove \ Math.Sqrt(2)
            Case FireDirections.RighBack
                deltaMoveX = deltaMove \ Math.Sqrt(2)
                deltaMoveY = deltaMove \ Math.Sqrt(2)
        End Select


        Me.Width = mainImage.Width
        Me.Height = mainImage.Height

    End Sub

    Public Overrides Sub Move(ByVal input As InputState)

        Me.Left += deltaMoveX
        Me.Top += deltaMoveY

    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)
        g.DrawImage(mainImage, Me.Rectangle, 0, 0, mainImage.Width, mainImage.Height, GraphicsUnit.Pixel, Attr)
    End Sub

    Public Overrides Function IsDead() As Boolean
        If Top > Common.Display.ViewArea.Bottom Then
            Return True
        ElseIf Top < 0 Then
            Return True
        ElseIf Left > Common.Display.ViewArea.Width Then
            Return True
        ElseIf Left < 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Overrides Property BelongTo As BelongTo
        Get
            Return BelongTo.Ally
        End Get
        Set(ByVal value As BelongTo)
            MyBase.BelongTo = value
        End Set
    End Property

    Public Overrides Sub Explode()
        '消滅時、爆発アニメーションなし
        Return
    End Sub

    Public Overrides ReadOnly Property IsFire As Boolean
        Get
            Return True
        End Get
    End Property
End Class

Public Enum FireDirections
    Forward
    Back
    RightForward
    LeftForward
    Right
    Left
    RighBack
    LeftBack
End Enum