﻿Public Class GiantBomber
    Inherits UnitBase

    Shared mainImages() As Bitmap

    Private deltaMove As Integer = 1

    ''' <summary>フレームごとに爆弾を発射する確率。1000で100%、1で0.1%。0なら発射しない。</summary>
    Public FireRate As Integer = 300

    Protected animateFrameCount As Integer
    Const ImageChangeFrameCount As Integer = 2

    Protected currentImageIndex As Integer

    Shared Attr As New Imaging.ImageAttributes

    Public Sub New()

        MyBase.New()

        If mainImages Is Nothing Then
            Dim baseImage As Bitmap = Image.FromFile(Application.StartupPath & "\image\GiantBomber.bmp")

            ReDim mainImages(5)
            mainImages(0) = baseImage.Clone(New Rectangle(0, 0, 64, 64), baseImage.PixelFormat)
            mainImages(1) = baseImage.Clone(New Rectangle(64, 0, 64, 64), baseImage.PixelFormat)
            mainImages(2) = baseImage.Clone(New Rectangle(128, 0, 64, 64), baseImage.PixelFormat)
            mainImages(3) = baseImage.Clone(New Rectangle(0, 64, 64, 64), baseImage.PixelFormat)
            mainImages(4) = baseImage.Clone(New Rectangle(64, 64, 64, 64), baseImage.PixelFormat)
            mainImages(5) = baseImage.Clone(New Rectangle(128, 64, 64, 64), baseImage.PixelFormat)

            'mainImage = Image.FromFile(Application.StartupPath & "\image\Bomb.bmp")
            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
        End If

        currentImageIndex = 0
        Me.Width = mainImages(currentImageIndex).Width
        Me.Height = mainImages(currentImageIndex).Height

    End Sub

    Public Overrides Sub Move(ByVal input As InputState)

        Me.Top += deltaMove

        If Common.Random.Next(1, 1000) < FireRate Then
            Dim abomb1 As New ABomb
            abomb1.Init(New Point(Me.Left, Me.Bottom), New Point(Common.mainUnit.Left, Common.mainUnit.Top))
            Common.RequestUnitAdd(abomb1)

            Dim abomb2 As New ABomb
            abomb2.Init(New Point(Me.Right, Me.Bottom), New Point(Common.mainUnit.Left, Common.mainUnit.Top))
            Common.RequestUnitAdd(abomb2)

            Dim abomb3 As New ABomb
            abomb3.Init(New Point(Me.Left + (Me.Width \ 2), Me.Bottom), New Point(Common.mainUnit.Left, Common.mainUnit.Top))
            Common.RequestUnitAdd(abomb3)
        End If

    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)

        animateFrameCount += 1

        If animateFrameCount = ImageChangeFrameCount Then
            animateFrameCount = 0
            currentImageIndex += 1

            If currentImageIndex > UBound(mainImages) Then
                currentImageIndex = 0
            End If
            
        End If

        g.DrawImage(mainImages(currentImageIndex), Me.Rectangle, 0, 0, Me.Width, Me.Height, GraphicsUnit.Pixel, Attr)

    End Sub

    Public Overrides ReadOnly Property MaxPower As Integer
        Get
            Return 3
        End Get
    End Property

    Public Overrides Function IsDead() As Boolean
        Return (Top > Common.Display.ViewArea.Height) Or MyBase.IsDead
    End Function

    Public Overrides ReadOnly Property GamePoint As Integer
        Get
            Return 500
        End Get
    End Property
End Class
