﻿Public Class Hardian
    Inherits UnitBase

    Shared mainImages() As Bitmap
    Shared Attr As New Imaging.ImageAttributes

    Public deltaMove As Integer = 1

    ''' <summary>フレームごとに爆弾を発射する確率。1000で100%、1で0.1%。0なら発射しない。</summary>
    Public FireRate As Integer = 100

    ''' <summary>このユニットが生成されてからの総経過フレーム数。</summary>
    Protected totalFrameCount As Double

    Protected currentImageIndex As Integer

    Public Sub New()

        MyBase.New()

        If mainImages Is Nothing Then
            Dim baseImage As Bitmap = Image.FromFile(Application.StartupPath & "\image\Hardian.bmp")

            ReDim mainImages(3)
            mainImages(0) = baseImage.Clone(New Rectangle(0, 0, 32, 32), baseImage.PixelFormat)
            mainImages(1) = baseImage.Clone(New Rectangle(0, 32, 32, 32), baseImage.PixelFormat)
            mainImages(2) = baseImage.Clone(New Rectangle(32, 0, 32, 32), baseImage.PixelFormat)
            mainImages(3) = baseImage.Clone(New Rectangle(32, 32, 32, 32), baseImage.PixelFormat)

            'mainImage = Image.FromFile(Application.StartupPath & "\image\Bomb.bmp")
            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
        End If

        currentImageIndex = 0
        Me.Width = mainImages(currentImageIndex).Width
        Me.Height = mainImages(currentImageIndex).Height

    End Sub

    Public Overrides Sub Move(ByVal input As InputState)

        Me.Top += deltaMove

        If Common.Random.Next(1, 1000) < FireRate Then
            Dim abomb As New ABomb
            abomb.Init(New Point(Me.Left, Me.Top), New Point(Common.mainUnit.Left, Common.mainUnit.Top))
            Common.RequestUnitAdd(abomb)
        End If

    End Sub


    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)

        Select Case PowerPoint
            Case Is > 9
                currentImageIndex = 0
            Case Is > 6
                currentImageIndex = 1
            Case Is > 3
                currentImageIndex = 2
            Case Else
                currentImageIndex = 3
        End Select

        g.DrawImage(mainImages(currentImageIndex), Me.Rectangle, 0, 0, Me.Width, Me.Height, GraphicsUnit.Pixel, Attr)

    End Sub

    Public Overrides Function IsDead() As Boolean
        Return (Top > Common.Display.ViewArea.Height) Or MyBase.IsDead
    End Function

    Public Overrides ReadOnly Property MaxPower As Integer
        Get
            Return 12
        End Get
    End Property

    Public Overrides ReadOnly Property GamePoint As Integer
        Get
            Return 200
        End Get
    End Property

End Class
