﻿Public Class PowerUp
    Inherits UnitBase

    Shared mainImages() As Bitmap
    Shared Attr As New Imaging.ImageAttributes

    ''' <summary>フレームごとに爆弾を発射する確率。1000で100%、1で0.1%。0なら発射しない。</summary>
    Public FireRate As Integer = 20

    ''' <summary>このユニットが生成されてからの総経過フレーム数。</summary>
    Protected totalFrameCount As Double

    Protected currentImageIndex As Integer

    Public Sub New()

        MyBase.New()

        If mainImages Is Nothing Then
            Dim baseImage As Bitmap = Image.FromFile(Application.StartupPath & "\image\PowerUp.bmp")

            ReDim mainImages(0)
            mainImages(0) = baseImage.Clone(New Rectangle(0, 0, 32, 32), baseImage.PixelFormat)
            'mainImages(1) = baseImage.Clone(New Rectangle(0, 16, 32, 16), baseImage.PixelFormat)
            'mainImages(2) = baseImage.Clone(New Rectangle(0, 32, 32, 16), baseImage.PixelFormat)

            'mainImage = Image.FromFile(Application.StartupPath & "\image\Bomb.bmp")
            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
        End If

        currentImageIndex = 0
        Me.Width = mainImages(currentImageIndex).Width
        Me.Height = mainImages(currentImageIndex).Height

    End Sub

    Public Overrides Sub Move(ByVal input As InputState)

        Dim pos As Point = Calculate()

        Me.Left = pos.X
        Me.Top = pos.Y

    End Sub


    ''' <summary>
    ''' 現在の座標を計算する。
    ''' ガリ(このユニット)の軌道は正弦関数のxとyを逆にした軌道。
    ''' yは時間とともに一定数増加する。
    ''' xはyの正弦関数の値
    ''' </summary>
    Private Function Calculate() As Point

        Dim x As Double
        Dim y As Double = totalFrameCount / 50

        x = -Math.Sin(y)

        '振れ幅調整。正弦関数(Math.Sin)の戻り値は-1から1の範囲なので、
        'これに、画面領域の幅の半分をかけて領域いっぱいに横位置が振れるようにする。
        x = x * (Common.Display.ViewArea.Width \ 2)
        x += (Common.Display.ViewArea.Width \ 2)

        totalFrameCount += 1

        Dim result As New Point(x, y * 50)
        Return result

    End Function

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)

        g.DrawImage(mainImages(currentImageIndex), Me.Rectangle, 0, 0, Me.Width, Me.Height, GraphicsUnit.Pixel, Attr)

    End Sub

    Public Overrides Function IsDead() As Boolean
        Return (Top > Common.Display.ViewArea.Height) Or MyBase.IsDead
    End Function

    Public Overrides Property BelongTo As BelongTo
        Get
            Return BelongTo.Item
        End Get
        Set(ByVal value As BelongTo)
            MyBase.BelongTo = value
        End Set
    End Property

End Class
