﻿Public Class StarA
    Inherits UnitBase

    Private mainImage As Bitmap
    Private deltaMove As Integer = 10

    Dim Attr As New Imaging.ImageAttributes
    'Dim actions As New ActionList

    Public PowerUpLevel As Integer = 0

    Public Sub New()

        MyBase.New()

        Dim fileName As String = Application.StartupPath & "\image\StarA.bmp"

        Me.mainImage = Image.FromFile(fileName)
        Me.Width = mainImage.Width
        Me.Height = mainImage.Height

        '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
        Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))

    End Sub

    ' ''' <summary>
    ' ''' ダメージを受けた時のアクションを行う。
    ' ''' 実際にはこのアクションの影響による座標の変更はMove時に計算・描画される。
    ' ''' </summary>
    ' ''' <remarks></remarks>
    'Public Sub AddDamage()
    '    actions.Add(New DamageAction)
    'End Sub
    Public Overrides Sub Move(ByVal input As InputState)

        '▼左移動の入力があるとき。(左の矢印キーが押されているとき)
        If input.Left Then
            Me.Left -= deltaMove
        End If

        '▼右移動の入力があるとき。(右の矢印キーが押されているとき)
        If input.Right Then
            Me.Left += deltaMove
        End If

        '▼上移動
        If input.Up Then
            Me.Top -= deltaMove
        End If

        '▼下移動
        If input.Down Then
            Me.Top += deltaMove
        End If


        '▼ビーム発射があるとき
        If input.Fire Then
            SoundComposer.Fire1.Play()
            input.Fire = False
            '左側のビーム
            Dim f1 As New FireA(FireDirections.Forward)
            f1.Top = Me.Top
            f1.Left = Me.Left
            Common.RequestUnitAdd(f1)

            '右側のビーム
            Dim f2 As New FireA(FireDirections.Forward)
            f2.Top = Me.Top
            f2.Left = Me.Right
            Common.RequestUnitAdd(f2)

            If PowerUpLevel >= 1 Then
                '後方ビーム
                Dim f3 As New FireA(FireDirections.Back)
                f3.Top = Me.Bottom
                f3.Left = Me.Left + (Me.Width \ 2)
                Common.RequestUnitAdd(f3)

                If PowerUpLevel >= 2 Then
                    '左前ビーム
                    Dim f4 As New FireA(FireDirections.LeftForward)
                    f4.Top = Me.Top
                    f4.Left = Me.Left
                    Common.RequestUnitAdd(f4)

                    '右前ビーム
                    Dim f5 As New FireA(FireDirections.RightForward)
                    f5.Top = Me.Top
                    f5.Left = Me.Right
                    Common.RequestUnitAdd(f5)

                    If PowerUpLevel >= 3 Then
                        '左ビーム
                        Dim f6 As New FireA(FireDirections.Left)
                        f6.Top = Me.Top
                        f6.Left = Me.Left
                        Common.RequestUnitAdd(f6)

                        '右ビーム
                        Dim f7 As New FireA(FireDirections.Right)
                        f7.Top = Me.Top
                        f7.Left = Me.Right
                        Common.RequestUnitAdd(f7)
                    End If

                End If
            End If

        End If

        ''アクション(=このサンプルではジャンプのみ)の影響による補正座標
        'Dim actionAffect As Point
        'Dim deadActions As New List(Of ActionBase)

        ''アクションによる補正座標の取得
        'For Each action As ActionBase In actions
        '    actionAffect += action.Calculate
        '    If action.IsFinish Then
        '        deadActions.Add(action)
        '    End If
        'Next

        ''終了したアクションを作動中のアクション一覧から削除
        ''消滅したユニットを一覧から削除
        'For Each action As ActionBase In deadActions
        '    actions.Remove(action)
        'Next


        ''アクション補正座標をプラスして最終的な座標を算出
        'Me.Left += actionAffect.X
        'Me.Top += actionAffect.Y

        '▼行動範囲(=画面)の外に出ないようにストッパー

        '左からはみ出してしまう場合、左端ぎりぎりの位置を指定
        If Me.Left < Common.Display.ViewArea.X Then
            Me.Left = 0
        End If

        '右からはみ出してしまう場合、右端ぎりぎりの位置を指定
        If Me.Right > Common.Display.ViewArea.Right Then
            Me.Left = Common.Display.ViewArea.Right - Me.Width
        End If

        '上
        If Me.Top < Common.Display.ViewArea.Y Then
            Me.Top = 0
        End If

        '下
        If Me.Bottom > Common.Display.ViewArea.Bottom Then
            Me.Top = Common.Display.ViewArea.Bottom - Me.Height
        End If


    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)
        g.DrawImage(mainImage, Me.Rectangle, 0, 0, mainImage.Width, mainImage.Height, GraphicsUnit.Pixel, Attr)
    End Sub

    Public Overrides Property BelongTo As BelongTo
        Get
            Return BelongTo.Ally
        End Get
        Set(ByVal value As BelongTo)
            MyBase.BelongTo = value
        End Set
    End Property

End Class
