﻿Public Class Straighter
    Inherits UnitBase

    Shared mainImages() As Bitmap
    'Private minimumMoveX As Integer = 10
    Private deltaMove As Integer = 8

    ''' <summary>フレームごとに爆弾を発射する確率。1000で100%、1で0.1%。0なら発射しない。</summary>
    Public FireRate As Integer = 20

    Protected animateFrameCount As Integer
    Const ImageChangeFrameCount As Integer = 10

    Protected currentImageIndex As Integer

    Shared Attr As New Imaging.ImageAttributes

    Public Sub New()

        MyBase.New()

        If mainImages Is Nothing Then
            Dim baseImage As Bitmap = Image.FromFile(Application.StartupPath & "\image\Straighter.bmp")

            ReDim mainImages(1)
            mainImages(0) = baseImage.Clone(New Rectangle(0, 0, 32, 32), baseImage.PixelFormat)
            mainImages(1) = baseImage.Clone(New Rectangle(0, 32, 32, 32), baseImage.PixelFormat)


            'mainImage = Image.FromFile(Application.StartupPath & "\image\Bomb.bmp")
            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
        End If

        currentImageIndex = 0
        Me.Width = mainImages(currentImageIndex).Width
        Me.Height = mainImages(currentImageIndex).Height

    End Sub

    Public Overrides Sub Move(ByVal input As InputState)

        Me.Top += deltaMove

        If Common.Random.Next(1, 1000) < FireRate Then
            Dim abomb As New ABomb
            abomb.Init(New Point(Me.Left, Me.Top), New Point(Common.mainUnit.Left, Common.mainUnit.Top))
            Common.RequestUnitAdd(abomb)
        End If

    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)
        'g.DrawImage(mainImage, Me.Rectangle, 0, 0, mainImage.Width, mainImage.Height, GraphicsUnit.Pixel, Attr)

        animateFrameCount += 1

        If animateFrameCount = ImageChangeFrameCount Then
            animateFrameCount = 0
            If currentImageIndex = 0 Then
                currentImageIndex = 1
            Else
                currentImageIndex = 0
            End If
        End If

        g.DrawImage(mainImages(currentImageIndex), Me.Rectangle, 0, 0, Me.Width, Me.Height, GraphicsUnit.Pixel, Attr)

    End Sub

    Public Overrides Function IsDead() As Boolean
        Return (Top > Common.Display.ViewArea.Height) Or MyBase.IsDead
    End Function
End Class
