﻿Public Class Titta
    Inherits UnitBase

    Shared mainImages() As Bitmap
    Private deltaMove As Integer = 8

    Protected Phase As Phases

    ''' <summary>フレームごとに爆弾を発射する確率。1000で100%、1で0.1%。0なら発射しない。</summary>
    Public FireRate As Integer = 10

    ' ''' <summary>このユニットが生成されてからの総経過フレーム数。</summary>
    'Protected totalFrameCount As Double

    Protected animateFrameCount As Integer
    Const ImageChangeFrameCount As Integer = 8

    Protected currentImageIndex As Integer

    Enum Phases
        ''' <summary>第１段階。直進。プレイヤー機とY座標が同じになると第２段階へ</summary>
        P1_Searcher
        ''' <summary>第２段階。急速反転。プレイヤー機の前方まで急速に移動する。移動完了後第３段階へ</summary>
        P2_MetPlayer
        ''' <summary>第３段階。直進。動きとしては第１段階と同じ</summary>
        P3_Searcher
    End Enum

    Shared Attr As New Imaging.ImageAttributes

    Public Sub New()

        MyBase.New()

        If mainImages Is Nothing Then
            Dim baseImage As Bitmap = Image.FromFile(Application.StartupPath & "\image\Titta.bmp")

            ReDim mainImages(3)
            mainImages(0) = baseImage.Clone(New Rectangle(0, 0, 32, 32), baseImage.PixelFormat)
            mainImages(1) = baseImage.Clone(New Rectangle(32, 0, 32, 32), baseImage.PixelFormat)
            mainImages(2) = baseImage.Clone(New Rectangle(0, 32, 32, 32), baseImage.PixelFormat)
            mainImages(3) = baseImage.Clone(New Rectangle(32, 32, 32, 32), baseImage.PixelFormat)

            'mainImage = Image.FromFile(Application.StartupPath & "\image\Bomb.bmp")
            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            Attr.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
        End If

        currentImageIndex = 0
        Me.Width = mainImages(currentImageIndex).Width
        Me.Height = mainImages(currentImageIndex).Height

    End Sub

    Dim Phase2MoveCount As Integer
    Dim Phase2MoveX As Integer
    Public Overrides Sub Move(ByVal input As InputState)

        Select Case Phase
            Case Phases.P1_Searcher
                Me.Top += deltaMove

                If Me.Top >= Common.mainUnit.Top Then
                    Me.Phase = Phases.P2_MetPlayer

                    Dim tanni As Integer = (Common.mainUnit.Left - Me.Left) \ 10
                    Phase2MoveX = tanni
                    '                    targetPositionX = Me.Left + (tanni * 10)
                End If

            Case Phases.P2_MetPlayer

                Phase2MoveCount += 1

                Me.Top -= deltaMove * 3
                Me.Left += Phase2MoveX

                If Phase2MoveCount > 10 Then
                    Me.Phase = Phases.P3_Searcher
                End If


            Case Phases.P3_Searcher
                Me.Top += deltaMove

        End Select

        If Common.Random.Next(1, 1000) < FireRate Then
            Dim abomb As New ABomb
            abomb.Init(New Point(Me.Left, Me.Top), New Point(Common.mainUnit.Left, Common.mainUnit.Top))
            Common.RequestUnitAdd(abomb)
        End If

    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)

        animateFrameCount += 1

        If animateFrameCount = ImageChangeFrameCount Then

            animateFrameCount = 0

            If Phase = Phases.P1_Searcher Then
                If currentImageIndex = 0 Then
                    currentImageIndex = 1
                Else
                    currentImageIndex = 0
                End If
            Else
                If currentImageIndex = 2 Then
                    currentImageIndex = 3
                Else
                    currentImageIndex = 2
                End If
            End If

        End If

        g.DrawImage(mainImages(currentImageIndex), Me.Rectangle, 0, 0, Me.Width, Me.Height, GraphicsUnit.Pixel, Attr)
    End Sub

    Public Overrides Function IsDead() As Boolean
        Return (Top > Common.Display.ViewArea.Height) Or MyBase.IsDead
    End Function
End Class
